org.apache.catalina.loader

## Class ParallelWebappClassLoader

- java.lang.Object
- - java.lang.ClassLoader
  - - java.security.SecureClassLoader
    - - java.net.URLClassLoader
      - - org.apache.catalina.loader.WebappClassLoaderBase
        - - org.apache.catalina.loader.ParallelWebappClassLoader

- All Implemented Interfaces:
    Closeable, AutoCloseable, Lifecycle, InstrumentableClassLoader, PermissionCheck

      public class ParallelWebappClassLoader
      extends WebappClassLoaderBase

  Parallel class loading implementation of WebappClassLoaderBase. Parallel class loading is only available when using a Java 7+ JRE.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.catalina.loader.WebappClassLoaderBase

      `WebappClassLoaderBase.PrivilegedFindResourceByName, WebappClassLoaderBase.PrivilegedGetClassLoader`

    - ### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

      `Lifecycle.SingleUse`

  - ### Field Summary

    - ### Fields inherited from class org.apache.catalina.loader.WebappClassLoaderBase

      `allPermission, canonicalLoaderDir, delegate, files, hasExternalRepositories, j2seClassLoader, jarFiles, jarNames, jarPath, jarRealFiles, lastJarAccessed, lastModifiedDates, loaderDir, loaderPC, needConvert, notFoundResources, packageTriggers, parent, paths, permissionList, repositories, repositoryURLs, resourceEntries, resources, searchExternalFirst, securityManager, sm, started, system, triggers`

    - ### Fields inherited from interface org.apache.catalina.Lifecycle

      `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ParallelWebappClassLoader()`
    `ParallelWebappClassLoader(ClassLoader parent)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ParallelWebappClassLoader` | `copyWithoutTransformers()` Returns a copy of this class loader without any class file transformers.

    - ### Methods inherited from class org.apache.catalina.loader.WebappClassLoaderBase

      `addLifecycleListener, addPermission, addPermission, addPermission, addRepository, addTransformer, addURL, check, clearReferences, closeJARs, copyStateWithoutTransformers, deleteDir, destroy, doDefineClass, filter, findClass, findClassInternal, findLifecycleListeners, findLoadedClass0, findLoadedResource, findRepositories, findResource, findResourceInternal, findResourceInternal, findResources, getAntiJARLocking, getClearReferencesHttpClientKeepAliveThread, getClearReferencesLogFactoryRelease, getClearReferencesRmiTargets, getClearReferencesStatic, getClearReferencesStopThreads, getClearReferencesStopTimerThreads, getContextName, getDelegate, getJarPath, getJavaseClassLoader, getPermissions, getResource, getResourceAsStream, getResources, getSearchExternalFirst, getState, getStateName, getURI, getURL, getURLs, init, isPackageSealed, isStarted, loadClass, loadClass, modified, openJARs, refreshPolicy, removeLifecycleListener, removeTransformer, setAntiJARLocking, setClearReferencesHttpClientKeepAliveThread, setClearReferencesLogFactoryRelease, setClearReferencesRmiTargets, setClearReferencesStatic, setClearReferencesStopThreads, setClearReferencesStopTimerThreads, setDelegate, setJarPath, setJavaseClassLoader, setParentClassLoader, setResources, setSearchExternalFirst, setWorkDir, start, stop, toString, validate, validateJarFile`

    - ### Methods inherited from class java.net.URLClassLoader

      `close, definePackage, newInstance, newInstance`

    - ### Methods inherited from class java.security.SecureClassLoader

      `defineClass, defineClass`

    - ### Methods inherited from class java.lang.ClassLoader

      `clearAssertionStatus, defineClass, defineClass, defineClass, defineClass, definePackage, findLibrary, findLoadedClass, findSystemClass, getClassLoadingLock, getPackage, getPackages, getParent, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, registerAsParallelCapable, resolveClass, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ParallelWebappClassLoader

          public ParallelWebappClassLoader()

    - #### ParallelWebappClassLoader

          public ParallelWebappClassLoader(ClassLoader parent)

  - ### Method Detail

    - #### copyWithoutTransformers

          public ParallelWebappClassLoader copyWithoutTransformers()

      Returns a copy of this class loader without any class file transformers. This is a tool often used by Java Persistence API providers to inspect entity classes in the absence of any instrumentation, something that can't be guaranteed within the context of a `ClassFileTransformer`'s `transform` method.

      The returned class loader's resource cache will have been cleared so that classes already instrumented will not be retained or returned.

      Returns:
        the transformer-free copy of this class loader.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.